﻿/*
 * JsCrypto_LEA.h
 *
 * Created: 2015-07-31 11:56:18 GMT+9
 *  Author: 이지찬 / Jichan Lee ( jic5760@naver.com / ablog.jc-lab.net )
 * License: Creative Commons License 2.0 - BY
 *          저작자표시시 상업적 이용, 자유로운 수정 및 배포가 가능합니다.
 */

#ifndef __JSCRYPTO_LEA_H__
#define __JSCRYPTO_LEA_H__


#ifdef _MSC_VER
#if _MSC_VER < 1600 // MSVC++ 10.0 _MSC_VER == 1600 (Visual Studio 2010)

#ifndef __JSSTDINT_TYPES__
#define __JSSTDINT_TYPES__
typedef __int8 int8_t;
typedef unsigned __int8 uint8_t;
typedef __int16 int16_t;
typedef unsigned __int16 uint16_t;
typedef __int32 int32_t;
typedef unsigned __int32 uint32_t;
typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;
#endif /* __JSSTDINT_TYPES__ */

#else
#include <stdint.h>
#endif /* _MSC_VER < 1600 */
#else
#include <stdint.h>
#endif /* _MSC_VER */


extern void JsCrypto_LEA_EncryptKeySchedule_128(unsigned char *K, uint32_t *RoundKey);
extern void JsCrypto_LEA_EncryptKeySchedule_192(unsigned char *K, uint32_t *RoundKey);
extern void JsCrypto_LEA_EncryptKeySchedule_256(unsigned char *K, uint32_t *RoundKey);
extern void JsCrypto_LEA_DecryptBlock(int Nr, uint32_t *RoundKey, unsigned char *plaintext, unsigned char *ciphertext);
extern void JsCrypto_LEA_EncryptBlock(int Nr, uint32_t *RoundKey, unsigned char *plaintext, unsigned char *ciphertext);

#endif /* __JSCRYPTO_LEA_H__ */

